<?php
// Sécurité : ne doit pas être exécuté s'il n'est pas lancé par un script autorisé
if ( !defined('OK') )  exit();

// Mode https obligatoire si connecté
if ( $https && ( !isset($_SERVER['HTTPS']) || $_SERVER['HTTPS'] == 'off' ) )  {
  header("Location: https://{$_SERVER['HTTP_HOST']}{$_SERVER['REQUEST_URI']}");
  $mysqli->close();
  exit();
}

// Si une demande de connexion est faite
if ( isset($_REQUEST['login']) && isset($_REQUEST['motdepasse']) )  {

  // Récupération des logins/mdp dans la base MySQL et comparaison
  // Attention : la connexion MySQL doit être établie par le script appelant
  $resultat = $mysqli->query('SELECT id, login, genre, mdp, autorisation, matieres, timeout FROM utilisateurs');
  while ( $r = $resultat->fetch_assoc() )
    if ( ( $r['login'] == $_REQUEST['login'] ) && ( $r['mdp'] == sha1($_REQUEST['motdepasse']) ) )  {
      // Interdiction de garder son identifiant de session
      session_regenerate_id(true);
      $_SESSION = array();
      // Interdiction de pouvoir se connecter aux autres site sur le même serveur
      $_SESSION[md5("$site")] = true;
      // Pour vérification/utilisation aux connexions ultérieures
      $_SESSION['client'] = $_SERVER['HTTP_USER_AGENT'];
      $_SESSION['ip'] = $_SERVER['REMOTE_ADDR'];
      $_SESSION['login'] = $_POST['login'];
      $_SESSION['id'] = $r['id'];
      $_SESSION['autorisation'] = $autorisation = $r['autorisation'];
      $_SESSION['matieres'] = $r['matieres'];
      $_SESSION['timeout'] = $r['timeout'];
      $_SESSION['time'] = time()+$_SESSION['timeout'];
      $resultat->free();
      
      // Si genre >= 5, cela signifie qu'on a demandé une régénération de mot de passe (connect.php)
      if ( $r['genre'] >= 5 )  {
        include('admin/fonctions.php');
        $mysqli->close();
        $mysqli = mysql_ecriture();
        requete('utilisateurs',"UPDATE utilisateurs SET mdp='pas de mot de passe', genre=MOD(genre,5) WHERE id = ${r['id']}");
        $mysqli->close();
        $mysqli = mysql_lecture();
      }
      // Retour au script appelant
      unset($_REQUEST['motdepasse']);
      return;
    }
  $resultat->free();
  // Utilisateur inconnu ou mot de passe faux
  $message_login = 'Cet identifiant/mot de passe n\'est pas correct&nbsp;!';
}
// Message par défaut
else
  $message_login = "Ce contenu est protégé. Vous devez vous connecter pour l'afficher.";

////////////
/// HTML ///
////////////

// Haut de page, menu et message ($p et $t doivent avoir été définis dans le script appelant)
include('haut.php');
$mysqli->close();

// Spécifique pour docs.php : répertoires parents
if ( isset($parents) )
  echo $parents;

// Si utilisateur déjà connecté, message d'erreur simple
if ( $autorisation )
  echo "\n<p class=\"warning\">Ce contenu est protégé. Vous n'avez pas les droits d'accès suffisants pour afficher ce contenu.</p>\n";
// Si utilisateur non déjà connecté, formulaire de connexion
else  {
  if ( $p != 'connect' || isset($_REQUEST['login']) )
    echo "\n<div class=\"warning\">$message_login</div>\n";
?>

<form class="warning" action="" method="post">
  <p class="ligne"><label for="login">Identifiant&nbsp;: </label><input type="text" name="login" id="login"></p>
  <p class="ligne"><label for="motdepasse">Mot de passe&nbsp;: </label><input type="password" name="motdepasse" id="motdepasse"></p>
  <p><input type="submit" name="Ok" value="Envoyer"></p>
  <p id="oubli"><a href="connect?oubli">Identifiant ou mot de passe oublié&nbsp;?</a></p>
  <p id="oubli"><a href="connect?creation">Créer un compte</a></p>
</form>

<?php
}

// Bas de page
include('bas.php');
exit();
?>
